

function drawBattery(current, voltages) {
    
   
	current = Math.round(current * 10) / 10;
	var canvas = document.getElementById("battery");
	var ctx = canvas.getContext("2d");
	ctx.clearRect(0, 0, canvas.width, canvas.height);

	var emplyColor = "#999";
	var currentColor = "#999"
	var lengthOfText = 45;
	var capWidth = 4;
	var capHeight = 15;
	var xMin = 2;
	var yMin = 2;
	var batteryWidth = canvas.width - 3 * capWidth - lengthOfText;
	var batteryHeight = canvas.height - 2 * yMin;
	
	if (current <= voltages[1]) {
		currentColor = "red";
	} else {
		if (current <= voltages[2]) {
			currentColor = "orange";
		} else {
			if (current <= voltages[3]) {
				currentColor = "#9ACD32";
			} else {
				currentColor = "green";
			}
		}
	}
	ctx.strokeStyle = currentColor;
	roundRect(ctx, xMin, yMin, batteryWidth, batteryHeight, 5, currentColor, 2);
	
	// Делим батарейку так, чтобы слева и справа остался отступ
	var tickOffset = 2;
	var tickCount = 6;
	//tickWidth = (batteryWidth - 2 * tickOffset) / (tickCount + tickOffset);
	var tickWidth = (batteryWidth - 2 * tickOffset) / tickCount - tickOffset;
	var diapason = voltages[4] - voltages[0];
	var currentTick = Math.round((current - voltages[0])/diapason*6);
	
	for (var i = 1; i <= tickCount; i++) {
		if (i > currentTick) {
			ctx.strokeStyle = emplyColor;
		}
		ctx.beginPath();
		ctx.lineWidth = tickWidth;
		ctx.moveTo((tickWidth + tickOffset) * i, yMin + 1.5 * tickOffset);
		ctx.lineTo((tickWidth + tickOffset) * i, yMin + batteryHeight - 1.5 * tickOffset);
		ctx.stroke();
	}

	// Кепка у батарейки
	ctx.beginPath();
	ctx.lineWidth = capWidth;
	ctx.strokeStyle = currentColor;
	ctx.moveTo(batteryWidth + 3 * tickOffset, (canvas.height - capHeight) / 2);
	ctx.lineTo(batteryWidth + 3 * tickOffset, (canvas.height - capHeight) / 2
			+ capHeight);
	ctx.stroke();

	var fontSize = 15;
	ctx.font = fontSize + "px Arial";
	ctx.fillStyle = "black";
	var xCoordBeginText = canvas.width - lengthOfText;

	if (current < 10) {
		xCoordBeginText = canvas.width - lengthOfText + 4;
	}
	ctx.fillText(current.toFixed(1) + i18next.t('v'), xCoordBeginText, canvas.height
            - fontSize + 4);
            


	// Подчеркивание
	ctx.beginPath();
	ctx.lineWidth = 0.5;
	ctx.strokeStyle = currentColor;
	ctx.moveTo(canvas.width - lengthOfText, canvas.height - fontSize + 8);
	ctx.lineTo(canvas.width - 2, canvas.height - fontSize + 8);
	ctx.stroke();
}