function roundRect(ctx, x, y, width, height, rad, strokeStyle, lineWidth, fillStyle) {
  if (typeof lineWidth === "undefined" ) {
    ctx.lineWidth = 3;
  }
  if (typeof rad === "undefined") {
    rad = 5;
  }
  ctx.beginPath();
  ctx.moveTo(x + rad, y);
  ctx.lineTo(x + width - rad, y);
  ctx.quadraticCurveTo(x + width, y, x + width, y + rad);
  ctx.lineTo(x + width, y + height - rad);
  ctx.quadraticCurveTo(x + width, y + height, x + width - rad, y + height);
  ctx.lineTo(x + rad, y + height);
  ctx.quadraticCurveTo(x, y + height, x, y + height - rad);
  ctx.lineTo(x, y + rad);
  ctx.quadraticCurveTo(x, y, x + rad, y);
  ctx.closePath();
  if (lineWidth) {
    ctx.lineWidth = lineWidth;
  }
  if (fillStyle) {
    ctx.fillStyle = fillStyle;
	ctx.fill();
  }
  if (strokeStyle) {
    ctx.strokeStyle = strokeStyle;
  }  
  ctx.stroke();  
}