-- Скрипт реализует вывод показаний гироскопа

-- Упрощение вызова функции взятия абсолютного значения из модуля math
local abs = math.abs
-- Количество светодиодов на базовой плате
local ledNumber = 4
-- Создание порта управления светодиодами
local leds = Ledbar.new(ledNumber)

-- Функция считывания показаний с гироскопа и вывода их на светодиоды
local function getGyro()
    -- Считывание показаний с гироскопа
    gx, gy, gz = Sensors.gyro()
    -- Модули показаний
    gx, gy, gz = abs(gx), abs(gy), abs(gz)
    -- Вывод угловой скорости вокруг оси X на 1-й светодиод с помощью уровня интенсивности зеленого цвета
    leds:set(0, 0, gx % 10 / 10, 0)
    -- Вывод угловой скорости вокруг оси Z на 2-й и 3-й светодиоды с помощью уровня интенсивности фиолетового цвета
    leds:set(1, gz % 10 / 10, 0, gz % 10 / 10)
    leds:set(2, gz % 10 / 10, 0, gz % 10 / 10)
    -- Вывод угловой скорости вокруг оси Y на 4-й светодиод с помощью уровня интенсивности синего цвета
    leds:set(3, 0, 0, gy % 10 / 10)
end

-- Обязательная функция обработки событий
function callback(event)
end

-- Создание таймера, вызывающего функцию каждую 0.1 секунды
getGyroTimer = Timer.new(0.1, function () getGyro() end)
-- Запуск таймера
getGyroTimer:start()